// The main simulation/iteration loop

#include <stdio.h>
#include "nummrit.h"
#include "maxvalue.h"
#include "optcom.h"
#include "adjust.h"
#include "hamil.h"

// /flgcom/
extern short autasn, autdel, optmiz, prtptl,
      prtkey, prtdif, prtvcm, pracnd;

// /spncom/
extern int ngrp, niso, nvar;

// /asncom/
extern double *asnfrq, *asnwgt, *asndif, *asnclc, asnint;
extern int    asncnt, *asnlin;

//	from adjust.cpp
//  iteration parameters
extern double rms, rms_old;
extern int itrcnt, delcnt;
extern short iting;

// extern void prkeys(); 
// extern void prpart();
//extern int hamil(short, short);
//extern int trnclc(short, short);
//extern void trnasn(double);

// extern void prmchk(short);

extern int trnclc(const char *sim_out, short savtran, short dodifs);

int hamlup(const char *sim_out,  short oldham)
{
	int error = FALSE;
	short dodifs /*, tmperr */;

	iting = optmiz;
	dodifs = optmiz || prtptl;
	itrcnt = 0;

	if(iting && (asncnt < nvar))		// iterating but number of asssigned lines
	{									// less that number of variables
		error = hamil(sim_out, iting, FALSE);

		if(error == FALSE)
		{
			error = trnclc(sim_out, TRUE, FALSE);// Hamiltonian OK so calculate transitions
			trnasn(sim_out, asnlim * linwid);	// and autoassign lines
		}										// endif
	}											// endif

	if(error == FALSE && (!oldham || prtkey))	// do Hamiltonian
	{
		error = hamil(sim_out, iting, dodifs);											/////
	}

	if(error == FALSE)
		error = trnclc(sim_out, TRUE, dodifs);					// calculate transitions

	if(error == FALSE && optmiz)
	{
		dodifs = FALSE;
//		prmchk(tmperr);

		do
		{
			error = adjust(sim_out);					// calculate necessary adjustments
			if(iting)									// to parameters
			{
				if(error == FALSE) error = hamil(sim_out, iting, dodifs);
				if(error == FALSE) error = trnclc(sim_out, TRUE, dodifs);
			}											// endif

		} while(error == FALSE && iting);

		if(error == FALSE && prtkey) error = hamil(sim_out, iting, dodifs);
		if(error == FALSE) error = trnclc(sim_out, TRUE, dodifs);
	}													// endif
	return error;
}



