// header file for matrix utilities


int *ivector(int nl, int nh);
void free_ivector(int *v, int nl, int nh);
double **matrix(int nrl, int nrh, int ncl, int nch);
float **fmatrix(int nrl, int nrh, int ncl, int nch);
int **imatrix(int nrl, int nrh, int ncl, int nch);
//fcomplex **cmatrix(int nrl, int nrh, int ncl, int nch);
void  free_matrix(double **m, int nrl, int nrh, int ncl, int nch);
void  free_imatrix(int **m, int nrl, int nrh, int ncl, int nch);
double *vector(int nl, int nh);
void free_vector(double *v, int nl, int nh);
void matclear(double **m, int nrl, int nrh, int ncl, int nch, 
			  double value);
void imatclear(int **m, int nrl, int nrh, int ncl, int nch, 
			  int value);

void matdump(double **m, int nrl, int nrh, int ncl, int nch, char *title);
//void cmatdump(fcomplex **m, int nrl, int nrh, int ncl, int nch, char *title);
void imatdump(int **m, int nrl, int nrh, int ncl, int nch);

void iclear(int, int*, int);
void dclear(int, double*, double);
void sclear(int arrsiz, char* array);

int binint(int maxsize, int cursize, int *array, int key);

double fmax(double a, double b);
double fmin(double a, double b);
int imax(int a, int b);
int imin(int a, int b);
int pow2(int n);

double minmax(double minval, double curval, double maxval);

void symto(int n, int *pairg, double **asmmat, double **symmat);
void symfrm(int n, int *pairg, double **symmat, double **asmmat);

int ludcmp(int n, double **mat, int *index, double *scale, double *xchng);
void ludbak(int n, double **mat, int *index, double *rhs);

void matident(int size, double **mat);
int invert(int size, double **mat, double **inv);

