// maxvalue.h
// defines various maxima and matrix sizes for SpinWorks simulation

#define MAXGRP 14
#define MAXISO  14				//=MAXGRP
#define MXINAM  10
#define MXGNAM 6

#define MAXF 9
#define MAXVAR	78				//=MAXGRP*(MAXGRP+1)/2 

#define HMFACT 1  
#define HMFCT2	1				//=HMFACT*HMFACT,
#define MAXE2	4608			//=9*1024/HMFACT+1,
#define MAXE4	256				//=256/HMFACT, 
#define MAXM43	64				//=64/HMFACT,
#define MAXE3	256				//=MAXE4*MAXM43/(2*HMFACT),
#define MAXU3	122880			//=120*1024/HMFCT2,
//#define MAXU3	60000			//=120*1024/HMFCT2,
#define MPDINT	32				//=MAXE4/4, 
#define MPDTRI	528				//=MPDINT*(MPDINT+1)/2

#define MAXOBS 2000 
#define MAXASN 10000
#define MAXCLC 50000
#define DELPCT 20 
